# Datei: scom_txy.py (Python3)
# Autor: gkemnitz
# letzte Aenderung: 08.09.2016
#
# Versenden, Empfang und Ausgabe einer Zeichenkette der Laenge 1 bis ...
# Zusaetzliche Ausgabe der Uebertragungszeit zwischen Sendebeginn 
# und Empfangsabschluss.
#
# Auf dem Mikrorechner muss das Programm "echo" laufen.
# Als COM-Schnittstelle die der seriellen Verbindung einstellen,
# wahlweise fuer die Kabel- oder die Bluetooth-Verbindung.


import serial
from time import clock  
ser = serial.Serial("COM3", timeout=1)
send = "Das ist ein sehr langer String!".encode("ascii")
l = 1
dt_list=[];                # leere Liste fuer dt-Werte
while l<=len(send):        # Wiederhole bis Gesamtlaenge
  ts = clock();            # neuer Block => einruecken
  ser.write(send[:l])      # Sende die ersten l Zeichen
  y = ser.read(l).decode() # Warte auf l empfangene Zeichen
  dt = clock()-ts          # Zeitdifferenz zur Startzeit
  dt_list.append(dt)       # Differenzzeiten an Liste haengen
  print("Empfangene Daten: " + y, "dt= " + str(dt*1000)+" ms")
  l = l+1;
ser.close()

# zum Plotten ist die Klasse "pyplot" zu importieren
import matplotlib.pyplot as plt
plt.hold(True)
plt.plot(range(1, len(dt_list)+1), dt_list) # plot erstellen
plt.xlabel("Anzahl der Bytes") # Achsen beschriften
plt.ylabel("dt in ms")
plt.show()                     # anzeigen

