/* Datei:  com_pc.c
 * Author: gkemnitz
 * Letzte nderung:  08.09.2016
 *
 * Serielle PC-Kommunikation
 * Funktionssammlung
 *
 * PmodUSBUSART am JH (USART2)
 */ 


#include <avr/io.h>

// Initialisierung von USART2 (Protokoll 8N1, 9600 Baud)
void com_pc_init(){
  UCSR2C=0b110;                 // bertragungsformat 8N1
  UBRR2=51;                     // 9600 Baud
  UCSR2B=(1<<RXEN2)|(1<<TXEN2); // Empfnger und Sender ein
}

// ein Byte empfangen
uint8_t getByte(){
  while (!(UCSR2A & (1<<RXC2))); // warte auf ein Byte
  return UDR2;                   // Byte zurckgeben
}

// ein Byte senden
void sendByte(uint8_t dat){
  while (!(UCSR2A & (1<<UDRE2)));// warte Puffer frei
  UDR2 = dat;                    // Byte bernehmen
}
