# Datei: test_com_pc.py (Python3)
# Autor: gkemnitz
# letzte Aenderung: 08.09.2016
#
# Modultest fuer das Mikrorechnerprogramm "test_com_pc.c".
# Die Testbeispiele, jeweils zwei Zahlen, stehen in einem Tupel,
# werden nacheinander an den Mikrorechner geschickt, dessen 
# Ergebnisse, die Summe, die Differenz, ... der beiden Zahlen,
# abgeholt und mit den in Python berechneten Werten verglichen. 
#
# Auf dem Mikrorechner muss das Programm "test_com_pc" laufen.
# Als COM-Schnittstelle die der seriellen Verbindung einstellen,
# wahlweise fuer die Kabel- oder die Bluetooth-Verbindung.

import serial
ser = serial.Serial("COM9")# COM anpassen!
# Testbeispiele
i_tuple = ((27, 87), (220, 20), (110, 4), (218, 219))
for inp in i_tuple:        # fuer alle Testbeispiele
 ser.write(bytearray(inp)) # Tupel als Byte-Array senden
 x = ser.read(8)
 a = x[0]; b = x[1]; s = x[2]
 d = x[3]; q = x[4]; r = x[5]
 p = x[6] * 256 + x[7]                                 
 print('a=%3i, b=%3i Summe: %i %s'%(a, b,s,str(s==a+b)))
 print(13*' '+'Differenz:%i %s'%(d, str(d==a-b)))
 print(13*' '+'Quotient: %i Rest: %i (%s)'%(q, r, str(a==q*b+r)))
 print(13*' '+'Produkt:  %i (%s)'%(p, str(p==a*b)))
ser.close()
    
