/* Datei:  test_sonar.c
 * Author: gkemnitz
 * Datum:  21.10.2016
 *
 * Beispiel 2 zu Foliensatz 4
 * Ausgabe des Sonar-Abstandswerts auf LEDs
 * LD1 bis LD8 an Port J 
 *
 * SONAR-Module an JD unten (USART1).
 * Jumper JDX "gekreuzt (=)"
 */ 

#include <avr/io.h>
#define NEW_DAT	(UCSR1A & (1<<RXC1))

void sonar_init() {
  // Initialisierung von USART1
  UCSR1C = 0b110;      // Übertragungsformat 8N1
  UBRR1 = 51;          // 9600 Baud
  UCSR1B = (1<<RXEN1); // Empfänger ein
  DDRD  |= 1 << PD5;   // PD5 Ausgang
  PORTD |= 1 << PD5;   // Sonar einschalten
}

uint16_t getSonar(){
  // Sensorwert abholen
  uint8_t c, z=0;
  uint16_t w;
  while(1){  
                       // Warte auf Byte          
    while(!(UCSR1A & (1<<RXC1))); 
    c = UDR1;          // Byte Lesen
    if (z==0 && c=='R'){// Kante Z0 => Z1
      w=0; z=1;
    }
                       // Kanten Z1 bis Z4 und Ziffer
    else if(z>0 && z<4 && c>='0' && c<='9'){ 
      z++; w=10*w+c-'0';
    }
                       // Kante Z5 und 0x13
    else if(z==4 && c==0x0D){
      return w;
    }
    else z=0;          // sonst-Kanten
  }
} 


int main() {
  sonar_init();        // Sensor initialisieren
  DDRJ = 0xFF;         // LED-Ausgabe initialisieren
  while(1){
    uint16_t s = getSonar();// Wert abholen
    PORTJ = s & 0xFF;  // Wert ausgeben
  }	
}