/* Datei: test_comir_tmr.c
 * Autor: gkemnitz
 * letzte Änderung:  30.10.2015
 *
 * Testprogramm für den Gerätetreiber comir_tmr
 */ 


#include <avr/io.h>
#include <avr/interrupt.h>
#include "comir_tmr.h"

int main(){
  tmr_init();              // Timer-Treiber initialisieren
  DDRJ = 0xFF;             // Port J LED-Ausgabe     
  sei();                   // Interrupts global ein
  while(1){
    if (!tmr_restzeit(0)){ // wenn Kanal 0 abgelaufen
      PORTJ ^=0x40;        // LD6 (PJ.6) invertieren
      tmr_start(12, 0);    // Kanal 0 mit 1,2 s init.
   }
   if (!tmr_restzeit(1)){  // wenn Kanal 1 abgelaufen
      PORTJ ^=0x80;        // LD7 (PJ.7) invertieren
      tmr_start(07, 1);    // Kanal 1 mit 0,7 s init.
    }
    // Zeit in s auf LD[4:0] ausgeben
    uint8_t tmp = (tmr_get()/10) & 0x1F;
    PORTJ = (PORTJ & ~0x1F) | tmp;
  }
}
