/* Datei:  comir_sonar.c
 * Author: gkemnitz
 * Datum:  09.11.2016
 *
 * Quellprogramm fr den Gertetreiber comir_sonar
 *
 * SONAR-Module an JD unten (USART1).
 * Jumper JDX "gekreuzt (=)"
 */ 


 #include "comir_sonar.h"
 #include <avr/interrupt.h>

 uint16_t snr_val;
 uint8_t  snr_state;

void sonar_init(){           // Initialisierung Treiber + USART1
  UCSR1C=0b110;              // bertragungsformat 8N1
  UBRR1=51;                  // 9600 Baud
  UCSR1B=(1<<RXEN1); 	     // Empfnger ein (Senden unverndert)
  DDRD |= 1<<PD5;            // PE1 Ausgang
  PORTD |= 1<<PD5;           // Sonar einschalten
  snr_state =0;              // Empfangsautomat initialisieren
  UCSR1B |= (1<<RXCIE1);     // Empfangsinterrupt ein
}


ISR(USART1_RX_vect){         // Empfangs-ISR
  uint8_t dat = UDR1;        // Zeichen lesen
  if (snr_state==0 && dat=='R'){// Kante von Z0 nach Z1  
    snr_state = 1;       
    snr_val   = 0;   
  }                           // "Ziff"-Kanten
  else if (snr_state>0 && snr_state<4 && dat>='0' && dat<='9'){
    snr_val = (snr_val*10) + (dat-'0');
    snr_state++;
    return;
  }                           // Kante von Z4 nach Z5
  else if(snr_state==4 && dat==0x0D)
    snr_state = 5;
  else if (snr_state<5)
    snr_state = 0;            // "sonst"-Kanten
}

 
uint8_t sonar_get(uint16_t *sptr){
  uint8_t UCSR1B_bak = UCSR1B;// Int.-Freigabe speichern
  UCSR1B &= ~(1<<RXCIE1);     // Empfangs-Interrupt aus
  if (snr_state>=4) {         // wenn neuer Wert da,
    *sptr = snr_val;          // * ausgeben
    snr_state = 0;            // * Zustand rcksetzen
    UCSR1B = UCSR1B_bak;      // * Int.-Freigabe wiederherstellen
    return 1;                 // * Rcksprung mit "wahr"
  }
    UCSR1B = UCSR1B_bak;      // Int.-Freigabe wiederherstellen
    return 0;                 // Rcksprung mit "falsch"
 }
