/*
 * test_comir_lcd.c
 *
 * Created: 09.03.2015 12:41:28
 * Author: gkemnitz
 */ 


#include <avr/io.h>
#include <avr/interrupt.h>
#include "comir_tmr.h"
#include "comir_lcd.h"

#define INITSTR "W0:.. x W1:.. x Zeit:....s E:..."
#define LCP_W0T   3       // Restzeit Timer-Kanal 0
#define LCP_W0Z   6       // Zustand Timer-Kanal 0
#define LCP_W1T  11       // Restzeit Timer-Kanal 1
#define LCP_W1Z  14       // Zustand Timer-Kanal 1
#define LCP_ZEIT 21       // Zeit seit Programmstart in s

int main(void){
  uint8_t z0='0', z1='0'; // Ausgabezustand
  tmr_init();             // alle Treiber initialisieren
  lcd_init((uint8_t*)INITSTR);
	
  // nicht behandelter Interrupt ca. alle 8 s
  TCCR4B = 0b101;         // Timer 4, Normalmodus, Vorteiler
  TIMSK4 = 1<<TOIE4;      // 1024, berlaufinterrupt ein
		
  sei();                  // Interrupts global ein
  while(1){
    if (!tmr_restzeit(0)){// wenn Kanal 0 abgelaufen
      tmr_start(31, 0);   // Kanal 0 mit 3,1 s init.
      lcd_disp_chr(z0, LCP_W0Z);
      z0 ^=1;             // '0' (0x30) <=> '1' (0x31)
    }
    if (!tmr_restzeit(1)){// wenn Kanal 1 abgelaufen
      tmr_start(17, 1);   // Kanal 1 mit 1,7 s init.
      lcd_disp_chr(z1, LCP_W1Z);
      z1 ^=1;             // '0' (0x30) <=> '1' (0x31)
    }
    // Zeitwerte immer aktualisieren
    lcd_disp_val(tmr_restzeit(0),LCP_W0T, 2);
    lcd_disp_val(tmr_restzeit(1),LCP_W1T, 2);
    lcd_disp_val(tmr_get()/10, LCP_ZEIT, 4);	
  }
}
