/* Datei: boardtest.c
 * Autor: gkemnitz
 * Datum: 04.06.2015
 *
 * Ausgabe einer wandernden Eins.  
 * An alle Ports sind dazu gegebenenfalls ueber Kabel 
 * Led-Module anzuschliessen.
 */ 


#include <avr/io.h>

uint8_t LedDat[11];

void SetLed(){
  // Ausgabe von LedDat an die Ports
  PORTH = LedDat[0];
  PORTE = LedDat[1];
  PORTK = LedDat[2];
  PORTA = LedDat[3];
  PORTG = LedDat[4];
  PORTJ = LedDat[5];
  PORTC = LedDat[6];
  PORTD = LedDat[7];
  PORTL = LedDat[8];
  PORTB = LedDat[9];
  PORTF = LedDat[10];
  // Warten bis zun naechsten Timerueberlauf
  // nach ca. 1s
  while (!(TIFR3 & (1<<TOV3)));
  TIFR3 = (1<<TOV3);
}

int main(void){
  uint8_t i, j;
  DDRH = 0xFF; DDRE = 0xFF;
  DDRK = 0xFF; DDRA = 0xFF;
  DDRG = 0xFF; DDRJ = 0xFF; 
  DDRC = 0xFF; DDRD = 0xFF;
  DDRL = 0xFF; DDRB = 0xFF;
  DDRF = 0xFF;
  // Timmer3 fr Wartezeit 1s initialisieren
  TCCR3A = 0;
  TCCR3B = 0b011;
		
  for (i=0;i<10;i++){
    LedDat[i] = 0;
  }
			
  while(1){
    for (i=0;i<11;i++){
      LedDat[i] = 1;
      SetLed();
        for (j=0;j<7;j++){
          LedDat[i] = LedDat[i] << 1;
          SetLed();
        }
      LedDat[i] = 0;
    }
  }
}